package org.tbasket.handler

import org.tbasket.error.*
import zio.{Task, ZIO}
import zio.http.Body
import zio.json.*
import zio.json.ast.{Json, JsonCursor}

import scala.language.reflectiveCalls


object HandlerUtils {
  def parseAttribute[V, T <: Json {def value: V}](json: Json, name: String, cursor: JsonCursor[Json, T]): Task[V] =
    ZIO.fromEither(json.get[T](cursor).map(_.value))
      .mapError(InvalidRequest(s"Missing or invalid field $name.", _))
  
  def errorBody(errorType: String, msg: String) = Body.fromString(s"""{"error": "$errorType","msg": "$msg"}""")
  
  
  
}
